class Getem
  
  attr_accessor :params
    
  def fetch_n_post
    self.from_instagram
  end
  
  def from_instagram
    Instagram.tag_recent_media(App.app_config["instagram"]["tag_name"]).data.each do |photo|
      unless Cache.exists?(photo.id)
        Cache.add(photo)
        self.params = photo
        puts self.to_tumblr.inspect.green
      end
    end
  end

  def tumblr_api
    Tumblr.new(App.app_config["tumblr"]["email"], App.app_config["tumblr"]["password"])  
  end
  
  def to_tumblr
    puts "URL #{App.app_config["tumblr"]["url"]}"
    photo = format_tumblr_post
    puts photo.inspect.yellow
    request = tumblr_api.post(photo)
    request.perform do |response|
        if response.success?
            puts response.body.green  # Returns the new post's id.
        else
            puts "Something went wrong: #{response.code} #{response.message}".red
        end
    end
  end
  
  def format_tumblr_post
    photo = ::Tumblr::Post::Photo.new
    photo.private = false
    photo.group = App.app_config["tumblr"]["url"]
    photo.source = self.params.images.standard_resolution.url if self.params.images
    photo.caption = "#{self.params.caption.text.gsub(/##{App.app_config["instagram"]["tag_name"]}/, '')} by #{self.params.user.username}" if self.params.caption
    photo
  end
  
end